--Create Addon
---Console: print
---Events: get a whisper
TalentWhisper = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0");
local L = AceLibrary("AceLocale-2.2"):new("WelcomeHome");

--
TALENTWHISPER_KEYWORD = "[TalentWhisper]";   --Keyword to reply to
TALENTWHISPER_MIN_TIME_BETWEEN_REQUESTS = 3; --Min amount of seconds between two sends (without a min, you can get spammed and dc).
--TALENTWHISPER_BUSY = "TalentWhisper is busy, please try again in a few seconds.";
TALENTWHISPER_BUSY = L["TalentWhisper is busy, please try again in a few seconds."];

--Commands
local options = { 
	type = "group",
	args = {
		sendToGuild = {
			type = "execute",
			name = "/g",
			desc = L["Send your talent build to your guild channel"],
			func = function()
				TalentWhisper:Print_Talents_Mini("/g");
			end
		},
		sendToParty = {
			type = "execute",
			name = "/p",
			desc = L["Send your talent build to your party channel"],
			func = function()
				TalentWhisper:Print_Talents_Mini("/p");
			end
		},
		sendToRaid = {
			type = "execute",
			name = "/ra",
			desc = L["Send your talent build to your raid channel"],
			func = function()
				TalentWhisper:Print_Talents_Mini("/ra");
			end		
		},
		sendToSay = {
			type = "execute",
			name = "/s",
			desc = L["Send your talent build to the say channel"],
			func = function()
				TalentWhisper:Print_Talents_Mini("/s");
			end
		},		
		sendToOfficer = {
			type = "execute",
			name = "/o",
			desc = L["Send your talent build to your officer channel"],
			func = function()
				TalentWhisper:Print_Talents_Mini("/o");
			end
		},
		sendToBg = {			
			type = "execute",
			name = "/bg",
			desc = L["Send your talent build to your battleground channel"],
			func = function()
				TalentWhisper:Print_Talents_Mini("/bg");
			end	
		},
		sendToPlayer = {
			type = "text",
			name = "/w",
			desc = L["Send your talent build to this player"],
			usage = L["<PlayerName>"];
			set = function(name)
				TalentWhisper:Print_Talents_Mini("/w " .. name);
			end,
			get = function ()
				return L["<PlayerName>"];
			end
		},
		sendToChannel = {
			type = "text",
			name = "/c",
			desc = L["Send your talent build to this channel"],
			usage = L["<ChannelNumber>"];
			set = function(number)
				TalentWhisper:Print_Talents_Mini("/" .. number);
			end,
			get = function ()
				return L["<ChannelNumber>"];
			end
		}
	}
}

TalentWhisper:RegisterChatCommand({"/TalentWhisper", "/tw"}, options)

function TalentWhisper:OnInitialize()
    -- Called when the addon is loaded
end

function TalentWhisper:OnEnable()
    -- Called when the addon is enabled
    
    --Register Commands
	self:RegisterEvent("CHAT_MSG_WHISPER");	--Player gets a whisper
end

function TalentWhisper:OnDisable()
    -- Called when the addon is disabled
end

TalentWhisper_querytime = 0;
--Handle Events
function TalentWhisper:CHAT_MSG_WHISPER()
	local message = arg1;
	local player = arg2;
	if(string.find(string.lower(message), string.lower(TALENTWHISPER_KEYWORD), 1, true) ~= nil) then
		if(TalentWhisper:isNoSpam(TalentWhisper_querytime)) then
			TalentWhisper_querytime = GetTime();			
			TalentWhisper:Print_Talents_Mini("/w " .. player);
		else
			TalentWhisper:whisper(TALENTWHISPER_BUSY, player);
		end--if
		--TalentWhisper_cprint("Send Talents!");
	end--if
end
--Functions

--Test if it is spam
function TalentWhisper:isNoSpam(TalentWhisper_querytime)
	return (GetTime() - TalentWhisper_querytime >= TALENTWHISPER_MIN_TIME_BETWEEN_REQUESTS);
end

--Send a whisper to a player
function TalentWhisper:whisper(msg, player)
	SendChatMessage(msg, "WHISPER", nil, player);
end

function TalentWhisper:guild(msg)
	SendChatMessage(msg, "GUILD");
end

--Send a message to the party channel
function TalentWhisper:party(msg)
	SendChatMessage(msg, "PARTY");
end

--Send a message to the raid channel
function TalentWhisper:raid(msg)
	SendChatMessage(msg, "RAID");
end

--Send a message to the say channel
function TalentWhisper:say(msg)
	SendChatMessage(msg, "SAY");
end

--Send a message to the guild channel
function TalentWhisper:guild(msg)
	SendChatMessage(msg, "GUILD");
end

--Send a message to the battleground channel
function TalentWhisper:bg(msg)
	SendChatMessage(msg, "BATTLEGROUND");
end

--Send a message to the channel with number "number".
function TalentWhisper:channel(msg, number)
	SendChatMessage(msg, "CHANNEL", nil, number);
end

--Send a message to the officer channel
function TalentWhisper:officer(msg)
	SendChatMessage(msg, "OFFICER");
end

--Split a string, gotten from wowwiki
function TalentWhisper:GetCmd(msg)
	if msg then
		local a,b,c=strfind(msg, "(%S+)"); --contiguous string of non-space characters
		if a then
			return c, strsub(msg, b+2);
		else	
			return "";
		end
	end
end

--Send your talent build to the channel
--send: function-channel to use to send
--to: if you whisper, the player name | if you send to a /number channel, the number
function TalentWhisper:Print_Talents(msg)
	local numTabs = GetNumTalentTabs();
	
	for t=1, numTabs do
	    local nameTab, iconTexture, pointsSpent, background = GetTalentTabInfo(t);
	    if(pointsSpent ~= 0) then --Only send if the player gots points in it
	    	if(to) then
	    		send(pointsSpent .. " points in " .. nameTab .. ":", to);
	    	else
	    		send(pointsSpent .. " points in " .. nameTab .. ":");
	    	end
	    end
	    local numTalents = GetNumTalents(t);
	    for i=1, numTalents do
	        local nameTalent, icon, tier, column, currRank, maxRank = GetTalentInfo(t,i);
	        if(currRank ~= 0) then	--Only send if the player gots points in it
				sendstring = "- " .. nameTalent .. ": " .. currRank .. "/" .. maxRank;	        
	        
			    --We got the string to send, let's send it to the right channel!	
				local command, subcommand = TalentWhisper:GetCmd(msg);	
				
				if(command == "/w") then
					local user = subcommand;		
					if(user ~= nil) then
						TalentWhisper:whisper(sendstring, user);
					end
				elseif(command == "/g") then
					TalentWhisper:guild(sendstring);
				elseif(command == "/p") then
					TalentWhisper:party(sendstring);
				elseif(command == "/ra") then
					TalentWhisper:raid(sendstring);
				elseif(command == "/s") then
					TalentWhisper:say(sendstring);
				elseif(command == "/bg") then
					TalentWhisper:bg(sendstring);
				elseif(command == "/o") then
					TalentWhisper:officer(sendstring);
				else
					local numberstring = string.gsub(msg, "/", "");
					if(tonumber(numberstring)) then
						local to = tonumber(numberstring);
						TalentWhisper:channel(sendstring, to);			
					end
				end						
			end	    	
	    end
	end
end

--Send your talent build to the channel
--send: function-channel to use to send
--to: if you whisper, the player name | if you send to a /number channel, the number
--command: string-chanel to send to
--MINI: try to send it on as few lines as possible, max of 255 characters a line
function TalentWhisper:Print_Talents_Mini(msg)
	local numTabs = GetNumTalentTabs();
	
	for t=1, numTabs do
		local sendstring = "";	
	    local nameTab, iconTexture, pointsSpent, background = GetTalentTabInfo(t);
	    if(pointsSpent ~= 0) then --Only send if the player gots points in it
			sendstring = sendstring .. pointsSpent .. " points in " .. nameTab .. ": ";
	    end
	    local numTalents = GetNumTalents(t);
	    for i=1, numTalents do
	        local nameTalent, icon, tier, column, currRank, maxRank = GetTalentInfo(t,i);
	        if(currRank ~= 0) then	--Only send if the player gots points in it
				local oldstring = sendstring;
				sendstring = sendstring .. "- " .. nameTalent .. ": " .. currRank .. "/" .. maxRank .. " ";
				if (string.len(sendstring) > 255 and oldstring ~= "") then --Maximum of 255 characters a line
				    --We got the string to send, let's send it to the right channel!	
					local command, subcommand = TalentWhisper:GetCmd(msg);	
					
					if(command == "/w") then
						local user = subcommand;		
						if(user ~= nil) then
							TalentWhisper:whisper(oldstring, user);
						end
					elseif(command == "/g") then
						TalentWhisper:guild(oldstring);
					elseif(command == "/p") then
						TalentWhisper:party(oldstring);
					elseif(command == "/ra") then
						TalentWhisper:raid(oldstring);
					elseif(command == "/s") then
						TalentWhisper:say(oldstring);
					elseif(command == "/bg") then
						TalentWhisper:bg(oldstring);
					elseif(command == "/o") then
						TalentWhisper:officer(oldstring);
					else
						local numberstring = string.gsub(msg, "/", "");
						if(tonumber(numberstring)) then
							local to = tonumber(numberstring);
							TalentWhisper:channel(oldstring, to);			
						end
					end	
					sendstring = "- " .. nameTalent .. ": " .. currRank .. "/" .. maxRank .. " ";
				end--if
			end	    	
	    end
	    
	    --We got the string to send, let's send it to the right channel!	
		local command, subcommand = TalentWhisper:GetCmd(msg);	
		
		if(command == "/w") then
			local user = subcommand;		
			if(user ~= nil) then
				TalentWhisper:whisper(sendstring, user);
			end
		elseif(command == "/g") then
			TalentWhisper:guild(sendstring);
		elseif(command == "/p") then
			TalentWhisper:party(sendstring);
		elseif(command == "/ra") then
			TalentWhisper:raid(sendstring);
		elseif(command == "/s") then
			TalentWhisper:say(sendstring);
		elseif(command == "/bg") then
			TalentWhisper:bg(sendstring);
		elseif(command == "/o") then
			TalentWhisper:officer(sendstring);
		else
			local numberstring = string.gsub(msg, "/", "");
			if(tonumber(numberstring)) then
				local to = tonumber(numberstring);
				TalentWhisper:channel(sendstring, to);			
			end
		end		    
	end
end